package nl.imre.tbl;

/**
 * @author Imre Boersma
 * 
 * ID list for all tiles:
 * 0-7: Floor_1 - floor8
 * 8: Trap
 * 9: Wall Goo
 * 10-11: Wall Hole 1/2
 * 12: Wall
 * 13-16: Wall Banners B-G-R-Y
 * 17: Door closed
 * 18: Door open
 */
public enum Rooms {
	
	TITLESCREEN {
		@Override
		protected void init() {
			this.map = new int[][] {
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}, 
				{12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12}
			};
		}
	},

	STARTROOM {
		@Override
		protected void init() {
			this.map = new int[][] {
				{ 12,12,12,12,12,12,12,12,12,12,12,12,12,12,17,12,12,12,12,12,12,12,12,12,12,12,12,12,12},
				{ 12,0,0,0,0,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,12,12,12,12,12},
				{ 12,0,0,0,0,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,12,12,12,12,12},
				{ 12,0,0,0,12,12,12,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12},
				{ 12,0,0,0,12,12,12,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12},
				{ 12,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,12,12,12,12,12,12,0,0,0,0,12},
				{ 12,0,0,0,12,12,12,0,0,12,12,0,0,0,0,0,0,0,12,12,12,12,12,12,0,0,0,0,12},
				{ 12,0,0,0,0,0,0,0,0,12,12,0,0,0,1,0,0,0,12,12,12,12,12,12,0,0,0,0,12},
				{ 12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,12,12,12},
				{ 12,0,12,12,0,8,0,0,0,0,0,0,0,12,12,12,0,0,0,12,12,0,0,0,0,0,12,12,12},
				{ 12,0,12,12,0,0,0,0,12,12,12,0,0,12,12,12,0,0,0,12,12,0,0,0,0,0,12,12,12},
				{ 12,0,12,12,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,12,12,0,0,0,12,12,12,12,12},
				{ 12,0,12,12,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,12,12,12},
				{ 12,0,12,12,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,12,12,12},
				{ 12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12}

				};
		}
	},
	MAZEROOM {
		@Override
		protected void init() {
			this.map = new int[][] {
				{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,17,13,12,12,12,12},
				{12,0,0,12,0,12,12,0,0,0,12,0,0,0,12,12,12,12,0,12,0,12,0,0,0,12,12,12,12},
				{12,0,12,12,0,0,0,8,12,0,0,0,12,0,12,0,0,0,0,12,0,12,0,0,0,0,0,0,12},
				{12,0,9,12,0,12,12,12,12,12,12,12,12,0,12,0,12,12,0,9,0,12,8,12,12,12,0,12,12},
				{12,0,0,0,0,12,0,0,0,0,0,0,12,0,0,0,12,0,0,0,0,12,0,0,0,0,0,12,12},
				{12,0,12,12,0,12,8,12,12,12,12,12,12,12,12,0,12,0,12,12,12,12,0,12,12,12,12,12,12},
				{12,8,12,12,2,0,0,0,0,0,0,0,0,0,0,5,12,0,0,0,0,12,0,6,7,0,0,0,12},
				{12,0,0,12,12,12,9,12,12,12,12,12,12,9,12,12,12,12,12,12,12,12,12,12,12,12,12,0,12},
				{12,0,12,0,0,0,0,0,0,0,8,0,0,0,12,0,0,0,12,0,0,0,12,12,12,0,12,0,12},
				{12,0,12,0,12,12,12,12,0,12,12,12,12,0,12,0,12,0,12,0,12,0,0,0,12,0,12,0,12},
				{12,0,12,0,12,0,0,0,0,12,12,0,12,0,12,0,12,0,12,0,12,12,0,12,9,0,12,0,12},
				{12,0,0,0,0,0,12,12,12,12,12,0,12,5,12,0,12,0,0,0,0,12,0,12,0,0,12,5,12},
				{12,0,12,12,12,12,12,6,7,0,0,0,12,6,12,0,12,12,12,12,0,0,0,12,8,12,12,6,12},
				{12,0,0,0,0,8,0,0,12,12,12,0,12,0,8,0,0,0,0,12,12,12,0,0,0,0,0,0,12},
				{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12}
			};
		}
	},
	ENDROOM {
		@Override
		protected void init() {
			this.map = new int[][]{
				{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12 },
				{12,0,0,0,0,0,0,0,0,0,0,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,0,0,12,12,0,0,0,8,8,0,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,0,0,12,12,0,0,0,8,8,0,12,12,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,12 },
				{12,0,0,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,0,0,0,8,0,12 },
				{12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,0,0,0,0,0,14 },
				{12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,12,12,0,0,0,0,0,18 },
				{12,0,0,0,0,12,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,12,12,0,0,0,0,0,14 },
				{12,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,12,0,8,0,0,0,12 },
				{12,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,0,0,0,0,12,0,0,0,0,0,12,12,12,0,8,0,0,0,0,0,0,0,0,0,8,0,0,12 },
				{12,0,0,0,0,12,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,0,0,0,0,0,0,0,0,0,0,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12 },
				{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12 }

				};
		}
	};

	protected int[][] map = new int[15][29];
	
	protected abstract void init();
	
	public int[][] getMap() {
		this.init();
		return this.map;
	}
}
